import java.io.*;
import java.lang.*;

/*
This class is the monitor class with each object representing a node.
the data types associated are 
norouters  -- total no of routers.

mincost[] a float type having shortest distance to each node.

minnode[] an array having the next jump for each router at the index no same as router .. minnode[i] = j means..that 
the router needs to move to the jth node to get to i.

change[] an array which keeps track of the changes , whether an updata has been received and sent to node j in change[j].

printok is a datayppe to keep track of whether the nodes info is printed or not.

*/




class router
{
	int rno; 
	int norouters;int printok;
	 float cost[][]=new float[10][10];
	 float mincost[]= new float[10];
	 int minnode[]=new int[10];
	 int change[]=new int[10];
	
	router() {} //default constructor


	router(float[][] a,int no,int nor )// overloaded constructor.
	{
	 this.rno=no;
	 printok=0;
	 this.norouters=nor;
	
	//constructing cost and next hop matrix for the node initially.
	 for(int i=0;i<norouters;i++)
	     for(int j=0;j<norouters;j++)
		{cost[i][j]=50;}
	 for(int i=0;i<norouters;i++)
		{cost[i][i]=a[no][i];change[i]=1;mincost[i]=100;}
	 mincol();
	}

//function to compare the minimum cost with previous value and find out if it has changed.

	int compare(float a[])
	{
		int chg=0;
		for(int i=0;i<norouters;i++)
		{
		 if(a[i]!=mincost[i])
		 {chg=1;}
		}
	  return chg;
	}


//function to print minimum distance  and next hop node  for each node.
	void printmin()
	{	
		if(printok==0)
		{
		System.out.println("\nFrom node "+ rno);
		System.out.println("\ndest node      dist to dest        next node ");
			for(int i=0;i<norouters;i++)
				System.out.println(i+ "              "+ mincost[i]+ "                 "+ minnode[i]);
		}
		System.out.println();
	}

	//function to calculate the minimum distance to each node from invoking node.
	void mincol()
	{
		for (int i=0;i<norouters;i++ )
		{
			for(int j=0;j<norouters;j++)
			{
				if(cost[i][j]<=mincost[i])
				{	mincost[i]=cost[i][j];
					minnode[i]=j;
				}
			}
		}
	}



/*synchronised send function where the sending router waits until an update is received by some notify() call*/
synchronized void senddata(int no)
	{
    if(change[no]!=1)
	try
		{wait();}
	catch(Exception e){}
 	}


/*a synchronized receive data function where notification is made to signal an updation which has occured and to make a thread in wait state continue.*/
synchronized void recvdata()
	{
	 
	 notifyAll();
	 
	}


//a synchronized thread used primarily to terminate the program after specified time.

	synchronized void slep()
	{
		try
		{
		 Thread.sleep(3000);
		}catch(Exception e){System.out.println("exc in sleep "+ e);}
	}

}

/*
This class is the Thread class where each and every object represents an edge and its data types are the two routers r1,r2 associated with the 
edge.
it also has a flag to distinguish the normal threads from the thread to terminate the program.
*/

class edges extends Thread 
{
 	router r1,r2;
	router[] r= new router[10];
	int fl;
	int norouters;
	
	edges(router x[], int a)
	{
		for(int i=0;i<a ;i++)
			r[i]=x[i];

		norouters=a;
	}
	
	edges(router r1, router r2,int fl)
	{
	this.r1=r1;	
	this.r2=r2;
	this.fl=fl;
	}

	//function to calculate the minimum of 2 values
	float min(float a, float b)
	{
		if(a<b)
		  return a;
		else 
			return b;

	}
	

	//the run method of the threads.
	public void run()
	{
		int iter=0;

		//the method for terminating threads and program.
		if(fl==0)
		{
			  
			  r[1].slep();
			  r[1].recvdata();
			  for(int i=0;i<norouters;i++)
				  r[i].printmin();

			  System.exit(0);
		}


		while(iter<100 && fl!=0)
		{
	
		 
		 r1.senddata(r2.rno);//making r1 wait till update and send update to r2.
		 float prevmin[]=new float[10];
		 r1.change[r2.rno]=0;
		
		

		//updating r1 info to r2.
		 for(int i=0;i<r1.norouters;i++)
		 prevmin[i]=r2.mincost[i];
		 r1.mincol();
		
	     for(int i=0;i<r1.norouters;i++)
			{
			r2.cost[i][r1.rno]= r2.cost[r1.rno][r1.rno]+ r1.mincost[i];
			}
			r2.mincol();
		 if( (r2.compare(prevmin) )!=0)
			{
			for(int i=0;i<r1.norouters;i++) r2.change[i]=0;
			}
			
			r2.change[r2.rno]=0;
			
			r2.recvdata();
			iter++;

					

		}

	}

}


/*the main class which reads data from the file. and  constucts a general cost table. and send this to each routers.

it initiates the routers and also the threads for each edge and starts the edges.

*/

class dvr
{

	public static void main(String args[])

    {
		String s[]= new String[50];
		int no,n1,n2,noedges;int x=0;

		try
		{

		BufferedReader br= new BufferedReader(new FileReader(args[0]));
		while((s[x]=br.readLine())!=null){x++;};	
		}catch(Exception e){System.out.println("exception is " +e);}
		

		no=Integer.parseInt(s[0]);
		float cost[][]= new float[no][no];
		for(int i=0;i<no;i++)
			for(int j=0;j<no; j++)
		{cost[i][j]=50;cost[j][j]=0;}
				
		router r[] = new router[no];
		int  len=s.length;
		noedges=0;
		while(s[noedges]!=null){noedges++;}
		noedges--;
		int st[]=new int[noedges];
		int en[]=new int[noedges];
		edges ed[] = new edges[noedges];


		//calculation of edges length .. parsing from file.
		for(int j=1;s[j]!=null;j++)
			{
				n1= Integer.parseInt(s[j].substring(0,s[j].indexOf(" ")));
				n2= Integer.parseInt(s[j].substring(s[j].indexOf(" ")+1,s[j].lastIndexOf(" ")));
				float wt= Float.parseFloat(s[j].substring(s[j].lastIndexOf(" ")+1, s[j].length()));
				cost[n1][n2]=wt;
				
				st[j-1]=n1;en[j-1]=n2;

			}
			System.out.println("NO OF NODES ="+ no + "  no eges = "+ noedges);


		
		//instantiating routers. 
		for(int i=0;i<no;i++)
			r[i]=new router(cost,i,no);

		//instatiating threads for all edges.
		for(int k=0;k<noedges;k++)
		{ed[k] = new edges(r[st[k]],r[en[k]],1);}
	 	for(int k=0;k<noedges;k++)
	 	ed[k].start();	

		// terminating thread and printing
		 
		edges ee= new edges(r,no);
		ee.start();
		 
	}

}
